/*
Copyright 2015 Forward Computing and Control Pty. Ltd.
  ACN 003 669 994, NSW, Australia     All rights Reserved

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Further more 
 a) Neither the name of the author nor Forward Computing and Control may be 
   used to endorse or promote products derived from this software
   without specific prior written permission.

b) All advertising materials mentioning features or use of this
    software must display the following acknowledgment: 
    "This product includes software developed by Matthew Ford
     and Forward Computing and Control Pty. Ltd. 
    (http://www.forward.com.au)."


THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */
package au.com.forward.pfodQRpsk;

public class ApplicationSettings implements IApplicationSettings {

    public static String SSID_LABEL = "SSID: ";
    public static String SECURITY_LABEL = "Security: ";
    public static String PASSWORD_LABEL = "Password: ";
    public static String SSID = "pfodWifiConfigV1";
    public static String SECURITY = "WPA2-PSK";
    public static String PORTNO_LABEL = "PortNo: ";
    public static String PORTNO = "23";
    //public static String FEATURES_LABEL = "Features: ";
    private static String newLine;

    static {
        newLine = System.getProperty("line.separator");
    }

    @Override
    public String getNewLine() {
        return newLine;
    }

    @Override
    public String getLogFileName() {
        return logFileName;
    }

    /**
     * @return the version
     */
    @Override
    public String getVersion() {
        return versionString + "  31th March 2015";
    }

    /**
     * @return the APP_TITLE
     */
    @Override
    public String getAPP_TITLE() {
        return APP_NAME + " Rev" + versionString;
    }

//                    + "<br>Move your mouse in the text window to initialize the key generator."
//                + "<br>When the progress bar is full, the HMAC-SHA256 of your mouse movements"
//                + "<br>and the current computers nano sec time will be displayed."
//                + "<br>The result is essential random and not reproduceable a second time even using the exactly the same mouse movements."

    /**
     * @return the ABOUT_BOX_DESCRIPTION
     */
    @Override
    public String getABOUT_BOX_DESCRIPTION() {
        return "<html><br>This application generates 'random' 128 bit secret keys and encodes them as 22 alpha-numeric chars "
                + "<br>The 23rd char is always 'p'"
                + "<br>Move your mouse in the text window to initialize the key generator."
                + "<br>When the progress bar is full, the HMAC-SHA256 of your mouse movements"
                + "<br>and the current computers nano sec time will be displayed."
                + "<br>The result is essential random and not reproduceable a second time even using the exactly the same mouse movements."
                + "<br>"
                +"<br> This application is licenced under the terms and conditions in  http://www.forward.com.au/pfodQRpsk_Licence.txt"
                +"<br>"
                + "<br>This application includes hash code from &nbsp;&nbsp; http://www.gnu.org/software/gnu-crypto/ "
                + "<br>and QRcode from &nbsp;&nbsp; https://github.com/zxing/zxing &nbsp;&nbsp;under their respective licences";
    }

    /**
     * @return the Instructions
     */
    @Override
    public String getInstructions() {
        return INSTRUCTIONS;
    }

    public ApplicationSettings() {
    }

    public static String INSTRUCTIONS = newLine + "    This application generates 'random' 128bit secret keys and encodes them as 22 alpha-numeric chars" + newLine
            + "    The 23rd char is always 'p'" + newLine
            + "    The QRcode file is written to the same directory the pfodQRpsk.jar file is in" + newLine
            + "    The QRcode image contains the SSID, Security, Password and PortNo" + newLine
            + newLine + "    Move your mouse in the text window to initialize the key generator." + newLine
            + newLine
            + "    The HMAC-SHA256 of your mouse movements and the current computer's nano second time will be displayed" + newLine
            + "    The result is essential random and not reproduceable a second time" + newLine
            + "    even using the exactly the same mouse movements." + newLine;

    public static final int MIN_BYTES = 512;

    public static final String versionString = "1.5.1"; 
    // change file name to pfodWifiConfigV1_password

    public static final String FCC_HOME_PAGE = "www.forward.com.au";
    public static final String logFileName = "pfodQRpsk.txt";
    public static String logFileFirstLine = "Log File for pfodQRpsk Rev" + versionString + " ";
    public static String logFileCopyright = "(c)2015 Forward Computing and Control Pty. Ltd. (" + FCC_HOME_PAGE + ")";

    public static String logFileText = INSTRUCTIONS;

    public static final String APP_NAME = "pfodQRpsk";

    public static final String COPYRIGHT = "(c)2015 Forward Computing and Control Pty. Ltd";

    public static final String thePfodAddress = "www.pfod.com.au";

}
