/*
Copyright 2015 Forward Computing and Control Pty. Ltd.
  ACN 003 669 994, NSW, Australia     All rights Reserved

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Further more 
 a) Neither the name of the author nor Forward Computing and Control may be 
   used to endorse or promote products derived from this software
   without specific prior written permission.

b) All advertising materials mentioning features or use of this
    software must display the following acknowledgment: 
    "This product includes software developed by Matthew Ford
     and Forward Computing and Control Pty. Ltd. 
    (http://www.forward.com.au)."


THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */
package au.com.forward.pfodQRpsk;

import au.com.forward.logging.Logging;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Date;
import javax.swing.SwingUtilities;


public class pfodQRpsk {


    private static MainFrame mainFrame;
    private static ApplicationSettings applicationSettings;
    
    static {
        // set up logging  also redirects System.err and System.out
        // throws a LoggingException if problem with setting up Java logging
        // put all log files in current directory 
        String userHome = "." //System.getProperty("user.home",".")
                + System.getProperty("file.separator", "/");
        Logging.initializeLogging(userHome + ApplicationSettings.logFileName,
                ApplicationSettings.logFileFirstLine + new Date(), true, false);
        System.out.println(ApplicationSettings.logFileCopyright);
        // redirect System.out as well as System.err and append to existing log

    }

    public static ApplicationSettings getApplicationSettings() {
        return applicationSettings;
    }
    
    static class AppWindowAdapter extends WindowAdapter {
        @Override
        public void windowClosing(WindowEvent e) {
            System.err.println("Closing Application");
            SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                   mainFrame.exit();
                    //     quit(null);
                }
            });
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        applicationSettings = new ApplicationSettings();
        System.out.println(ApplicationSettings.logFileText);
        System.out.println();
        System.out.println(" Applicaton version:"+applicationSettings.getVersion());
        mainFrame = new MainFrame(); //new MainFrame();
        mainFrame.SSID_field.setText(ApplicationSettings.SSID);
        mainFrame.Security_field.setText(ApplicationSettings.SECURITY);
        mainFrame.PortNo_field.setText(ApplicationSettings.PORTNO);
        mainFrame.inputTextArea.setText(applicationSettings.getInstructions()); 
        mainFrame.addWindowListener(new AppWindowAdapter());
        mainFrame.pack();
        Dimension dims = Toolkit.getDefaultToolkit().getScreenSize();
        int ws = mainFrame.getSize().width;
        int hs = mainFrame.getSize().height;
        int xs = (dims.width - ws) / 2;
        int ys = (dims.height - hs) / 2;
        int minWidth = 800;
        int minHeight = 300;
        mainFrame.setMinimumSize(new Dimension(Math.min(ws,minWidth),hs));//new Dimension(minWidth,minHeight));
        mainFrame.setLocation(xs, ys);
        mainFrame.setTitle(applicationSettings.getAPP_TITLE()
              +" -- "+ApplicationSettings.thePfodAddress+" "
          +" "+ApplicationSettings.COPYRIGHT+" ");
        mainFrame.setVisible(true);
    }
}

